#pragma once
#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "NoteModel.h"
#include "EditBytes.h"
#include "WndSMSRecvList.h"
#include "SkinDialog.h"
#include "SMSController.h"
#include "SMSDropTarget.h"
#include "EditPhoneNumber.h"
#include "WorkGroupModel.h"
#include "UIListCommonDefine.hpp"
#include "AddChatWnd.h"
#include "SmsSearchWnd.h"
#include "NMDropTarget.h"


#define DEF_SMS_DLG_SIZE_CX				400
#define DEF_SMS_DLG_SIZE_CY				350
#define SMS_DLG_CONTROL_BORDER_COLOR	RGB(198,202,205)
#define SMS_DLG_BORDER_PIXEL			1
#define SMS_DLG_TEXT_BG_COLOR			RGB(34,34,34)
#define SMS_DLG_BG_COLOR				RGB(255,255,255)
#define SMS_DLG_EDIT_FONT_COLOR			RGB(136,136,136)
#define MAXSMSRECEIVER					50

#define ID_RECV_LIST					(0xE370)



using namespace DuiLib;



class CSMSSendWnd : public WindowImplBase,
    private IGTWASActorEvent,
    private IGTMessengerActorEvent
{
	DUI_DECLARE_MESSAGE_MAP()
		DUI_DECLARE_CUSTOM_MSG_MAP()
public:
	CSMSSendWnd(CWnd* pParent,const std::vector<CSMSModel::SMSReceiverInfo>& receiverVector);
	~CSMSSendWnd();

	LPCTSTR GetWindowClassName() const;
	void InitWindow();
	void OnPrepare(TNotifyUI& msg);
    LRESULT OnKeyDown(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& bHandled);
	LRESULT OnMouseWheel(UINT , WPARAM , LPARAM , BOOL& bHandled);
	virtual CDuiString GetSkinFile();
	virtual CDuiString GetSkinFolder();
	CSMSController* GetSMSController() { return m_pSMSController;}

	std::vector<CSMSModel::SMSReceiverInfo>* GetSMSReceivers();
	virtual void OnFinalMessage(HWND hWnd);
	void InitSkin();
	bool AddSMSReceiver(CString strID, CString strName, CString strCellPhone);
	void _OnBnClickedButtonSend(TNotifyUI& msg);
	void OnEventContent(int nID, int nBytes, void* pUser);
	//HWND Create( CWnd* pParentWnd/* =NULL */);
	bool OnGTWASActor_ResponseSMS( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_SMS_DATA &smsCount );
//	void SetDragAndDrop();
//	void CloseSMSDialog();
//	void OnEventPhoneNumber( int nID, void* pUser );
//	bool IsCloseMsg( MSG* pMsg );
	void OnBnClickedButtonClose();
	LRESULT OnReciverListDelUser( WPARAM wParam, LPARAM lParam );
	void SetWindowPosition(/*CRect rcParent*/);
	void AddUser(std::vector<NE_MEMBER_DATA>& vAddUsers);
	void CloseSmsSearchWnd(BOOL bClearSearchEdit, BOOL bSetFocusToRichEdit);
	void CloseSmsRecentContactWnd( BOOL bSetFocusToRichEdit);
	void DoSMSInvite();
	//void AddSMSReceiverFromInfo(CString strID, CString strName, CString strCellphone);

	void LoadInitialReceivers(const std::vector<CSMSModel::SMSReceiverInfo>& memberVector);
	void RefreshListBeforeOp();
	void RefreshListAfterOp();
	BOOL FindTelInSMSWnd(CString strTelNumber);
	void SetSenderText( );
	void InitializeMsgPopOnce();
	void AddSMSReceiverNode(CString strID, CString strName, CString strCellphone);
	void AddNodeFromNode(Node* pNode);
	LRESULT OnAddUserToSMS(Node* node);

	//static	bool RemoveNode(CListUI* pList,Node* node);
   
protected:
	LRESULT OnMsgSysKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void NotifyTextChange(TNotifyUI& msg);
	void OnNotifyReturn(TNotifyUI& msg);
	void InitMemberList(const std::vector<NE_MEMBER_DATA> &memberVector);
	bool RemoveNode(Node* node);
	Node* AddNode(const AddChatListItemInfo& item, Node* parent, const NE_MEMBER_DATA* pMembereData);
	void _OnCtrlSearchBtnClick(TNotifyUI& msg);
	void _OnCtrlSmsDelBtnClick(TNotifyUI& msg);
	void _OnCtrlSmsDelAllBtnClick(TNotifyUI& msg);
	void _OnCtrlRecentContactBtnClick(TNotifyUI& msg);

	void _OnNotifyKillFocus(TNotifyUI& msg);
    void _OnNotifySMSItemClick(TNotifyUI& msg);
	void _OnCtrlClickMsgTip(TNotifyUI& msg);
	void _OnCtrlClickTelTip(TNotifyUI& msg);
	void _OnCtrlAddBtnClick(TNotifyUI& msg);
	void RemoveAllReceiverList();
	void OnSearchUser();
	LRESULT OnCloseSmsSearchWnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void OnBnClickedButtonDelAllReceiver();
	void OnEscapeKeyInput(TNotifyUI& msg);
	void _OnCtrlSearchLabelClick(TNotifyUI& msg);
	void _OnCtrlSearchCancelClick(TNotifyUI& msg);
	LRESULT OnMsgCloseSMSSearch(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	LRESULT OnMsgCloseRecentSMSContact(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	void AssignDropTarget();
	LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	//LRESULT  OnNotifySMSListItemEditReturn(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	//void  OnNotifySMSListItemEditReturn(TNotifyUI& msg);
	void AddListItemSeperator();
	//void DelListItemSeperator();

	void AddListItemEditBoard();
	int _VerifyEditValue(TNotifyUI& msg);
    unsigned int _GetStringBytesCount(CString& str);
	void _TrunkTextToLimitBytes(CString& strInWindow);
	void SetEditListItemVisible(bool bVisible);
	//virtual LRESULT OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	//LRESULT OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	//Node* AddNode(const AddChatListItemInfo& item, Node* parent, const NE_MEMBER_DATA* pMembereData, GTUserStatusType status);
	//void ResizeList();
	//void InitMemberList(const std::vector<ORG_MEMBER_DATA> &memberVector);
	std::vector<CSMSModel::SMSReceiverInfo> m_receiverVector;
	//
	//	static void OnEventContent(int nID, int nBytes, void* pUser);
	//	static void OnEventPhoneNumber(int nID, void* pUser);
	//	bool IsCloseMsg( MSG* pMsg );
		CSMSController *m_pSMSController;
	
	//void SetDragAndDrop();
	//	void AddSMSReceiver(); 
	//	
	

	//	virtual bool OnGTWASActor_ResponseSMS(IGTWASActor *pActor, 	trid_t trid, 	GTWASCallErrorCode eErrorCode, 	const NE_SMS_DATA &smsCount	); 
	//public:
	//	
	//	afx_msg LRESULT		OnReciverListDelUser(WPARAM wParam, LPARAM lParam);
	//	afx_msg LRESULT		OnReciverListUserInfo(WPARAM wParam, LPARAM lParam);
	//	void CloseSMSDialog();
	//
	//	std::list<trid_t>	m_tridList;
	//	CEditPhoneNumber m_edAddPhoneNumber;
 //  SMSDropTarget *m_pDropTarget;
  // CWndSMSRecvList m_wndRecvList;
   //	CEditBytes m_edContent;
   //	CEditPhoneNumber m_edSender;

private:
	CString			m_strSearchWord;
	//CRect			m_rcClient;
	CDuiString		m_strID;
	
	CDialogBuilder  m_dlgBuilder;
	Node*			root_node_;
	CDuiRect		text_padding_;
	CWnd*			m_pParent;

	std::list<trid_t>	          m_tridList;
 //   int                           m_popID;
//	vector<CAddUserListData*>	m_vecMemberData;
	CSmsSearchWnd*              m_pSmsSearchWnd;
	CSmsRecentContactWnd*       m_pSmsRecentContactWnd;

	CNMDropTarget	m_DT;
	bool            m_bOnceRcverCountMsgBox;
};

